#include <stdio.h>
#include <string.h>
#include <allegro.h>
#include "edop.h"
#include "ymw.h"
#include "FileIO.h"
#include "mem.h"
#include "gfxhelp.h"
#include "find.h"
#include "lists.h"
#include "genproc.h"

#include "ContentDialog.h"

char *zone_command_desc_lister( int index, int *list_size );
char *thingy_lister( int index, int *list_size );
char *where_lister( int index, int *list_size );
int where_wrapper( int msg, DIALOG *d, int c );
int command_wrapper( int msg, DIALOG *d, int c );

DIALOG cont_prop_dlg[]=
{
     /* proc,                    x,   y,   w,   h,   fg,  bg,  key, flags,  d1,         d2, dp,                              dp2,                          dp3 */
/*00*/{ d_shadow_box_proc,       0,   0,   555, 103, CTX, CFG, 0,   0,      0,          0,  NULL,                            NULL,                         NULL },
/*01*/{ d_ctext_proc,            277, 2,   0,   0,   CTX, CFG, 0,   0,      0,          0,  "Edit a content entry",          NULL,                         NULL },
/*02*/{ command_wrapper,         5,   12,  176, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Type",                          zone_command_desc_lister,     NULL },
/*03*/{ d_droplistbutton_proc,   181, 12,  176, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Vnum",                          thingy_lister,                NULL },
/*04*/{ where_wrapper,           357, 12,  192, 12,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Where",                         where_lister,                 NULL },
/*05*/{ d_check_proc,            5,   30,  216, 8,   CTX, CFG, 0,   0,      1,          0,  "Dependant on previous (?)",     NULL,                         NULL },
/*06*/{ d_text_proc,             5,   40,  152, 8,   CTX, CFG, 0,   0,      1,          0,  "Maximum in world:",             NULL,                         NULL },
/*07*/{ d_num_edit_proc,         157, 40,  40,  8,   CTX, CBD, 0,   0,      5,          0,  "maxcnt",                        NULL,                         NULL },
/*17*/{ d_button_proc,           236, 76,  80,  15,  CTX, CFG, 0,   D_EXIT, 0,          0,  "Finished",                      NULL,                         NULL },
standarnd_dialog_chunks
};

int do_cont_prop_dlg( int index )
{
    int toss;

    cont_prop_dlg[2].d1 = world.zone[cur_zone].room[cur_room].content[index].type;
    if( cont_prop_dlg[2].d1 == 1 ){
      cont_prop_dlg[3].d1 = ifind_mobile_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].vnum );
      }
    else{
      cont_prop_dlg[3].d1 = ifind_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].vnum );
      }

    if( cont_prop_dlg[2].d1 == 4 ){
      cont_prop_dlg[4].d1 = ifind_object_vnum_zone( &world.zone[cur_zone], world.zone[cur_zone].room[cur_room].content[index].extra );
      }
    else{
      cont_prop_dlg[4].d1 = world.zone[cur_zone].room[cur_room].content[index].extra;
      }

    if( world.zone[cur_zone].room[cur_room].content[index].ifflag ){
      cont_prop_dlg[5].flags = D_SELECTED;
      }
    else{
      cont_prop_dlg[5].flags = 0;
      }

    strcpy( cont_prop_dlg[7].dp, "      " );
    itoa( world.zone[cur_zone].room[cur_room].content[index].max, cont_prop_dlg[7].dp, 10 );
    cont_prop_dlg[7].dp2 = &world.zone[cur_zone].room[cur_room].content[index].max;

    if( zone_command_desc_lister( cont_prop_dlg[2].d1, &toss ) ){
      cont_prop_dlg[2].dp = zone_command_desc_lister( cont_prop_dlg[2].d1, &toss );
      }
    if( thingy_lister( cont_prop_dlg[3].d1, &toss ) ){
      cont_prop_dlg[3].dp = thingy_lister( cont_prop_dlg[3].d1, &toss );
      }
    if( where_lister( cont_prop_dlg[4].d1, &toss ) ){
      cont_prop_dlg[4].dp = where_lister( cont_prop_dlg[4].d1, &toss );
      }

    do_dialog( cont_prop_dlg, index );

    world.zone[cur_zone].room[cur_room].content[index].type = cont_prop_dlg[2].d1;
    if( cont_prop_dlg[2].d1 == 1 ){
      world.zone[cur_zone].room[cur_room].content[index].vnum = world.zone[cur_zone].mobile[cont_prop_dlg[3].d1].vnum;
      }
    else{
      world.zone[cur_zone].room[cur_room].content[index].vnum = world.zone[cur_zone].object[cont_prop_dlg[3].d1].vnum;
      }

    if( cont_prop_dlg[2].d1 == 4 ){
      world.zone[cur_zone].room[cur_room].content[index].extra = world.zone[cur_zone].object[cont_prop_dlg[4].d1].vnum;
      }
    else{
      world.zone[cur_zone].room[cur_room].content[index].extra = cont_prop_dlg[4].d1;
      }

    if( cont_prop_dlg[5].flags & D_SELECTED ){
      world.zone[cur_zone].room[cur_room].content[index].ifflag = 1;
      }
    else{
      world.zone[cur_zone].room[cur_room].content[index].ifflag = 0;
      }

    return 0;
}

int cont_prop_dlg_init()
{
    set_colors( cont_prop_dlg );
    centre_dialog( cont_prop_dlg );

    return 0;
}

char *zone_command_desc_lister( int index, int *list_size )
{
    static char tmp[22];
    unsigned int j;

    if( index < 0 ){
      *list_size = 6;
      }

    strcpy( tmp, zone_command_desc[index] );

    for( j = 0; j < strlen( tmp ); j++ ){
       if( tmp[j] == '\"' )
         tmp[j] = '\0';
       }

    return tmp;
}

char *thingy_lister( int index, int *list_size )
{
    if( cont_prop_dlg[2].d1 == 1 ){
      if( index < 0 ){
        *list_size = world.zone[cur_zone].num_mobiles;
        return NULL;
        }
      return world.zone[cur_zone].mobile[index].short_desc;
      }
    else{
      if( index < 0 ){
        *list_size = world.zone[cur_zone].num_objects;
        return NULL;
        }

      return world.zone[cur_zone].object[index].short_desc;
      }
}

char *where_lister( int index, int *list_size )
{
    static char tmp[85];

    if( cont_prop_dlg[2].d1 == 3 ){
      if( index < 0 ){
        *list_size = 18;
        return NULL;
        }
  
      return zone_command_wear_desc[index];
      }
    else if( cont_prop_dlg[2].d1 == 4 ){
      if( index < 0 ){
        *list_size = world.zone[cur_zone].num_objects;
        return NULL;
        }

      sprintf( tmp, "in %s", world.zone[cur_zone].object[index].short_desc );
      tmp[22] = '\0';
      return tmp;
      }

    *list_size = 0;
    return NULL;
}

int where_wrapper( int msg, DIALOG *d, int c )
{
    if( cont_prop_dlg[2].d1 != 3 &&
        cont_prop_dlg[2].d1 != 4 ){
      d->flags |= D_DISABLED;
      }
    else{
      d->flags &= ~D_DISABLED;
      }

    return d_droplistbutton_proc( msg, d, c );
}

int command_wrapper( int msg, DIALOG *d, int c )
{
    static int od1=-1;
    int ret;

    ret = d_droplistbutton_proc( msg, d, c );

    if( od1 != d->d1 ){
      cont_prop_dlg[3].d1 = 0;
      cont_prop_dlg[4].d1 = 0;
      cont_prop_dlg[3].d2 = 0;
      cont_prop_dlg[4].d2 = 0;
      od1 = d->d1;
      ret = D_REDRAW;
      }

    return ret;
}

